--
-- c_ped_shell.lua
--

local myShader
local startTickCount = 0

addEventHandler( "onClientResourceStart", resourceRoot,
	function()

		-- Version check
		if getVersion ().sortable < "1.3.1-9.04939" then
			outputChatBox( "Resource is not compatible with this client." )
			outputChatBox( "Please update MTA:SA." )
			return
		end

		-- Create shader
		myShader, tec = dxCreateShader ( "fx/ped_shell_layer.fx", 0, 0, true, "ped" )

		if not myShader then
			outputChatBox( "Could not create shader. Please use debugscript 3" )
		else
			outputChatBox( "Using technique " .. tec )

			-- Apply shader to local player
			engineApplyShaderToWorldTexture ( myShader, "*", localPlayer )

			-- Hack to make GTA render the ped last, so our shell effect appears on top of the background
			setElementAlpha( localPlayer, 254 )

			outputChatBox( "Press 'm' to see the effect" )

			-- Fire effect at startup
			startEffect();
		end
	end
)


----------------------------------------------------------------
-- Start effect here
----------------------------------------------------------------
function startEffect()
	startTickCount = getTickCount()
end

bindKey("m", "down", startEffect )


----------------------------------------------------------------
-- Update effect here
----------------------------------------------------------------
addEventHandler( "onClientRender", root,
	function()
		if not myShader then return end

			local timeElapsed = getTickCount() - startTickCount
			local f = timeElapsed / 750
			f = math.min( f, 1 )

			local alpha = math.lerp ( 1.0, 0.0, f )
			local size = math.lerp ( 0, 0.3, f )

			-- Expand shell
			dxSetShaderValue( myShader, "sMorphSize", size, size, size )

			-- Fade out shell
			dxSetShaderValue( myShader, "sMorphColor", 1, 0, 0, alpha )
	end
)


----------------------------------------------------------------
-- Math helper functions
----------------------------------------------------------------
function math.lerp(from,to,alpha)
    return from + (to-from) * alpha
end
